//
//  PokktManager.h
//  PokktManager
//
//  Created by Pokkt on 2/27/15.
//  Copyright (c) 2015 Pokkt. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "PokktController.h"

static NSString * ACTION            = @"pokkt_receiver";
static NSString * TRANSACTION_ID    = @"transaction_id";
static NSString * MESSAGES          = @"message";

static NSString * SECURITY_KEY      = @"security_key";
static NSString * APPLICATION_ID    = @"application_id";
static NSString * USER_ID           = @"U_ID";
static NSString * INTEGRATION_TYPE  = @"integration_type";

static NSString * AUTO_CACHE_VIDEO  = @"auto_cache_video";


@interface PokktManager : NSObject

@property (nonatomic, strong, readonly)  NSString * integrationType;
@property (nonatomic, strong, readonly)  NSString * applicationId;
@property (nonatomic, strong, readonly)  NSString * UID;
@property (nonatomic, strong, readonly)  NSString * SDKVersion;
@property (nonatomic, strong, readonly)  NSString * videoVC;
@property (nonatomic, strong, readonly)  NSString * securityKey;
@property (nonatomic, readonly)          BOOL       autoCacheVideo;
//@property (nonatomic, readonly)          BOOL       isLogEnabled;

@property (nonatomic, strong) NSString * name;
@property (nonatomic, strong) NSString * age;
@property (nonatomic, strong) NSString * sex;
@property (nonatomic, strong) NSString * location;
@property (nonatomic, strong) NSString * martial_Status;
@property (nonatomic, strong) NSString * birthday;
@property (nonatomic, strong) NSString * facebook_ID;
@property (nonatomic, strong) NSString * twitter_Handle;
@property (nonatomic, strong) NSString * education_Information;
@property (nonatomic, strong) NSString * nationality;
@property (nonatomic, strong) NSString * employment_Status;
@property (nonatomic, strong) NSString * content_type;
@property (nonatomic, strong) NSString * opt_userId;



+ (id)sharedInstance;

+ (id)sharedInstance:(NSDictionary *)userInfoDict;

- (void)setPokktDelegate:(id<PokktDelegate>)mDelegate;

- (void)setPresentView:(UIViewController *)controller;

+ (void)setDebugger:(BOOL)isEnable;

- (BOOL)isVideoAvailable;

- (void)setDefaultSkipTime:(int)timeInSec;

- (void)setSkipVideo:(BOOL)boolVal;

- (void)cacheVideoCampaign;

- (void)setPubs:(NSArray *)arr;

- (void)playVideoCampaign:(BOOL)aIsIncentivisied withScreenName:(NSString *)screenName;




@end
